/************************************************************
 * MAT259 PROJ 2 : 3D Interaction & Change Over Time        *
 *                                                          *     
 * Junxiang Yao                                             *   
 *                                                          *
 *                                                          *
 * Usage: Press 1 / 2 / 3 / 4 / 5 / 6 to check movie        *
 *        individually.                                     * 
 *                                                          *  
 *        Press 7 / 8 to check the original / prequel       *
 *        trilogy.                                          *
 *                                                          *
 *        Press 9 / 0 to check all in one / different       *
 *        cordinate systems.                                *
 *                                                          *
 *        Press D to show / hide dots of duration           *
 *        times.                                            *
 *                                                          *
 *        Press S to show / hide the solids.                *
 *                                                          *
 *        Press N to show / hide the cromatic frames.       *
 *                                                          * 
 *        Press F to show / hide grey frames.               *
 *                                                          *    
 *        Press T to show / hide the verbal information.    * 
 *                                                          *
 *        Press L to show / hide the cordinate axis and     *
 *        lables.                                           *
 *                                                          * 
 *        Press G to show / hide the grid system.           *
 *                                                          * 
 *                                                          *
 * Tags:  Interaction - Keyboard Control                    *
 *                                                          *
 *        data        - Containing the data() function      *
 *                      which draws the cordinate axises    * 
 *                      and the dots and calls other        * 
 *                      ralated functions.                  *
 *                                                          *
 *        drawLine    - Including drawHLine() & drawVLine() *
 *                      which draw longitude and latitude.  *
 *                                                          *
 *        drawShape   - Containing drawShape() which paints *
 *                      the color between longitude and     *
 *                      latitude.                           *
 *                                                          *  
 *        gui         - draw verbal information and legends.*
 *                                                          *
 *        mousePressed- Containing mouse pressing events    *
 *                      related code.                       *
 *                                                          *
 ************************************************************/




import controlP5.*;

ControlP5 cp5;

import peasy.*;
import peasy.org.apache.commons.math.*;
import peasy.org.apache.commons.math.geometry.*;
import peasy.test.*;

PeasyCam cam;

PFont f;


int horMargin = 90;
int verMargin = 100;

Table table;//for checkout times
Table table1;//for duration times
Table table2;
Table table3;
Table table4;
Table table5;
Table table6;

int rows;
//matrix countaining data about checkout times
float[][] dataMatrix1;
float[][] dataMatrix2;
float[][] dataMatrix3;
float[][] dataMatrix4;
float[][] dataMatrix5;
float[][] dataMatrix6;

//matrix countaining data about duration times
float[][] duMatrix1;
float[][] duMatrix2;
float[][] duMatrix3;
float[][] duMatrix4;
float[][] duMatrix5;
float[][] duMatrix6;


int year = 10, month =12;
float radM, radY;



boolean fill = true;// paint color on each surfaces
boolean duration = true;//show dots
boolean line = false;//hide the grey frames
boolean cline = true;//show the cromatic frames
boolean [] s;//whether the structure is show or not
boolean [] center;//whether the structure is shown on the center or not

boolean [] highlightingYear;//whether the data of years are highlighted 
boolean [] highlightingMonth;//whether the data of months are highlighted 
boolean grid = false;//hide the grid system
boolean discription = true;//show the verbal information
boolean label = true;//show the cordinate circles and lables
boolean showTitle = true;//show the title of the movie near the cordinate circles
boolean showLegend = false;//hide the legend

String[] monthName = {"January", "February", "March", "April", "May", "June", "July", "August", 
  "September", "October", "November", "December"};
String[] m = {"Jan.", "Feb.", "Mar.", "Apr.", "May", "Jun.", "Jul.", "Aug.", 
  "Sep.", "Oct.", "Nov.", "Dec."};
String[] movieTitle = {"Star Wars I : \nThe Phantom Menace\n1999 ", 
  //"Star War I : \nThe Phantom Menace     \n1999       ", 
  "Star Wars II : \nAttack of the Clones\n2002 ", 
  "Star Wars III : \nRevenge of the Sith\n2005 ", 
  "Star Wars IV : \nA New Hope\n1977 ", 
  "Star Wars V : \nThe Empire Strikes Back\n1980 ", 
  "Star Wars VI : \nReturn of the Jedi\n1983 "};


void setup() {
  size(1280, 720, P3D);

  cam = new PeasyCam(this, 1620);
  cam.setMinimumDistance(200);
  cam.setMaximumDistance(1800);

  f = createFont("Arial", 100);


  highlightingYear = new boolean [10];
  highlightingMonth = new boolean [12];
  s = new boolean [6];
  center = new boolean [6];
  for (int i = 0; i < year; i++) {
    highlightingYear[i]=false;
  }
  for (int i = 0; i < month; i++) {
    highlightingMonth[i]=false;
  }

  for (int i = 0; i < 6; i++) {
    s[i]=true;
  }
  for (int i = 0; i < 6; i++) {
    center[i]=false;
  }

  table = new Table();
  //table1 = new Table();
  table = loadTable("starwarcheckout.csv", "header");

  table1 = loadTable("starwar1_duration.csv", "header");
  table2 = loadTable("starwar2_duration.csv", "header");
  table3 = loadTable("starwar3_duration.csv", "header");
  table4 = loadTable("starwar4_duration.csv", "header");
  table5 = loadTable("starwar5_duration.csv", "header");
  table6 = loadTable("starwar6_duration.csv", "header");


//------------------------------
//Initialize the checkout data
//------------------------------


  cp5 = new ControlP5(this);
  dataMatrix1 = new float[year][month];
  dataMatrix2 = new float[year][month];
  dataMatrix3 = new float[year][month];
  dataMatrix4 = new float[year][month];
  dataMatrix5 = new float[year][month];
  dataMatrix6 = new float[year][month];



  for (int i = 0; i < year; i++) {
    for (int j = month-1; j >=0; j--) {
      dataMatrix1[i][month-1-j] = table.getInt(i*month+j, 2);
    }
  }

  for (int i = 0; i < year; i++) {
    for (int j = month-1; j >=0; j--) {
      dataMatrix2[i][month-1-j] = table.getInt(i*month+j, 3);
    }
  }
  for (int i = 0; i < year; i++) {
    for (int j = month-1; j >=0; j--) {
      dataMatrix3[i][month-1-j] = table.getInt(i*month+j, 4);
    }
  }
  for (int i = 0; i < year; i++) {
    for (int j = month-1; j >=0; j--) {
      dataMatrix4[i][month-1-j] = table.getInt(i*month+j, 5);
    }
  }
  for (int i = 0; i < year; i++) {
    for (int j = month-1; j >=0; j--) {
      dataMatrix5[i][month-1-j] = table.getInt(i*month+j, 6);
    }
  }
  for (int i = 0; i < year; i++) {
    for (int j = month-1; j >=0; j--) {
      dataMatrix6[i][month-1-j] = table.getInt(i*month+j, 7);
    }
  }
    
    
//-----------------------------
//Initialize the duration data
//-----------------------------

  duMatrix1 = new float[year][month];
  duMatrix2 = new float[year][month];
  duMatrix3 = new float[year][month];
  duMatrix4 = new float[year][month];
  duMatrix5 = new float[year][month];
  duMatrix6 = new float[year][month];
  
  for (int i = 0; i < year; i++) {
    for (int j = month-1; j >=0; j--) {
      duMatrix1[i][month-1-j] = table1.getInt(i*month+j, 2);
    }
  }

  for (int i = 0; i < year; i++) {
    for (int j = month-1; j >=0; j--) {
      duMatrix2[i][month-1-j] = table2.getInt(i*month+j, 2);
    }
  }
  for (int i = 0; i < year; i++) {
    for (int j = month-1; j >=0; j--) {
      duMatrix3[i][month-1-j] = table3.getInt(i*month+j, 2);
    }
  }
  for (int i = 0; i < year; i++) {
    for (int j = month-1; j >=0; j--) {
      duMatrix4[i][month-1-j] = table4.getInt(i*month+j, 2);
    }
  }
  for (int i = 0; i < year; i++) {
    for (int j = month-1; j >=0; j--) {
      duMatrix5[i][month-1-j] = table5.getInt(i*month+j, 2);
    }
  }
  for (int i = 0; i < year; i++) {
    for (int j = month-1; j >=0; j--) {
      duMatrix6[i][month-1-j] = table6.getInt(i*month+j, 2);
    }
  }
}


void draw() {  
  smooth();
  rotateX(-.5);
  rotateY(-.5);
  background(56, 48, 60);
  if (s[0]) {
    pushMatrix();  
    int move1;
    if (center[0]) {
      move1 = 0;
      rotateY(0);
    } else {
      move1 = 600;
      rotateY(2*PI/3+PI);
    }
    data(dataMatrix1, move1, 0, color(#ff3535), color(#ffcccc), 
      20, 100, duMatrix1, movieTitle[0]);
    popMatrix();
  }
  if (s[1]) {
    pushMatrix();
    int move2;
    if (center[1]) {
      move2 = 0;
      rotateY(0);
    } else {
      move2 = 600;
      rotateY(TWO_PI);
    }
    data(dataMatrix2, move2, 0, color(#fe9a2e), color(#fcd7ae), 
      20, 100, duMatrix2, movieTitle[1]);
    popMatrix();
  }
  if (s[2]) {
    pushMatrix();
    int move3;
    if (center[2]) {
      move3 = 0;
      rotateY(0);
    } else {
      move3 = 600; 
      rotateY(TWO_PI+PI/3);
    }
    data(dataMatrix3, move3, 0, color(#edc628), color(#edeadc), 
      20, 100, duMatrix3, movieTitle[2]);
    popMatrix();
  }
  if (s[3]) {
    pushMatrix();   
    int move4;
    if (center[3]) {
      move4 = 0;
      rotateY(0);
    } else {
      move4 = 600; 
      rotateY(TWO_PI+2*PI/3);
    }
    data(dataMatrix4, move4, 0, color(#70b70a), color(#b8fcf0), 
      20, 100, duMatrix4, movieTitle[3]);
    popMatrix();
  }
  if (s[4]) {
    pushMatrix();
    int move5;
    if (center[4]) {
      move5 = 0;
      rotateY(0);
    } else {
      move5 = 600;
      rotateY(TWO_PI+PI);
    }
    data(dataMatrix5, move5, 0, color(#4c97dc), color(#b7cbff), 
      20, 100, duMatrix5, movieTitle[4]);
    popMatrix();
  }
  if (s[5]) {
    pushMatrix();    
    int move6;
    if (center[5]) {
      move6 = 0;
      rotateY(0);
    } else {
      move6 = 600;
      rotateY(PI/3+PI);
    }
    data(dataMatrix6, move6, 0, color(#6d6cca), color(#c898df), 
      20, 100, duMatrix6, movieTitle[5]);
    popMatrix();
  }

  if (discription) {
    gui();
  }
}