void data(float[][]dataMatrix, float x, float z, color c, color cb, int a, 
  color cl, float[][]duMatrix, String movieTitle) {
  pushMatrix();
  fill(10);
  translate(x, 0, z);


  //-----------------------------
  //draw sordinats and labels
  //-----------------------------

  //draw coordinate_month--------
  if (label) {
    pushMatrix();
    noFill();
    rotateY(PI/2);
    stroke(180);
    strokeWeight(1);
    ellipse(0, 0, 400, 400);

    for (int i = 0; i < month; i++) {
      noFill();
      pushMatrix();
      float theta = (i+1)*PI/13;
      translate(200*cos(theta+PI/2), 200*sin(theta+PI/2));
      rotate(theta+PI/2+PI);
      textAlign(LEFT, CENTER);
      fill(180);
      textSize(10);
      text(m[month-1-i], 1, 0);
      popMatrix();
    }
    if (showTitle) {
      textAlign(RIGHT, CENTER);
      fill(180);
      textSize(20);
      text(movieTitle, 190, 0);
      //text(movieTitle, 190, 80);
    }
    popMatrix();



    //draw coordinate_year------------------------
    pushMatrix();
    noFill();
    rotateX(PI/2);
    stroke(180);
    strokeWeight(1);
    ellipse(0, 0, 400, 400);

    for (int i = 2006; i < 2006+year; i++) {
      pushMatrix();
      float theta = (2006+year-i)*TWO_PI/10;
      translate(200*cos(theta+PI/2), 200*sin(theta+PI/2));
      rotate(theta+PI/2+PI);
      textAlign(RIGHT, CENTER);
      fill(180);
      textSize(12);
      text(i+" ", 0, 0);
      popMatrix();
    }
    popMatrix();
  }



  //-----------------------------
  //draw dots
  //-----------------------------
  if (duration) {
    for (int i = 0; i < year; i++) {
      color dcolor = c;
      for (int k = 0; k < year; k++) {
        if (highlightingYear[k]==true && k == i) {
          dcolor = cb;
        }
      }
      radY=i*TWO_PI/year;
      for (int j = 0; j < month; j++) {
        stroke(dcolor, 150);
        for (int k = 0; k < month; k++) {
          if (highlightingMonth[k]==true && k == month - j - 1) {
            stroke(cb, 150);
          }
        }
        radM=(j+1)*(float)PI/13;

        strokeWeight(duMatrix[i][j]/10);
        float r = dataMatrix[i][j];  
        point(r*sin(radY)*sin(radM), r*cos(radM), r*cos(radY)*sin(radM));
      }
    }
  }



  //-----------------------------
  //call other functions
  //-----------------------------

  //for surface
  if (fill) {
    drawShape(dataMatrix, c, cb, a);
  }

  //for cromatic frame
  if (cline) {
    drawHLine(dataMatrix, c);
    drawVLine(dataMatrix, c);
  }
  
  
  //for grey frame
  if (line) {
    drawHLine(dataMatrix, cl);
    drawVLine(dataMatrix, cl);
  } 
  popMatrix();
}